using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Syncfusion.Windows.Forms.Diagram;

namespace Diagram_WF_NodeEvents
{
    public partial class Form1 : Form
    {
        SymbolPalette palette = new SymbolPalette();
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            Ellipse myEllipse = new Ellipse(0, 0, 75, 50);
            Syncfusion.Windows.Forms.Diagram.Rectangle myRectangle = new Syncfusion.Windows.Forms.Diagram.Rectangle(0, 0, 75, 50);
            Ellipse myCircle = new Ellipse(0, 0, 50, 50);


            palette.AppendChild(myCircle);
            palette.AppendChild(myEllipse);
            palette.AppendChild(myRectangle);

            this.paletteGroupView1.LoadPalette(palette);

            this.diagram1.DragDrop += new DragEventHandler(diagram1_DragDrop);
            this.diagram1.EventSink.NodeClick += new NodeMouseEventHandler(EventSink_NodeClick);
            this.diagram1.EventSink.NodeDoubleClick += new NodeMouseEventHandler(EventSink_NodeDoubleClick);
            this.diagram1.Model.EventSink.PinPointChanging += new PinPointChangingEventHandler(EventSink_PinPointChanging);
            this.diagram1.Model.EventSink.SizeChanged += new SizeChangedEventHandler(EventSink_SizeChanged);
            this.diagram1.Model.EventSink.RotationChanged += new RotationChangedEventHandler(EventSink_RotationChanged);
            this.diagram1.MouseClick += new MouseEventHandler(diagram1_MouseClick);
        }

        void EventSink_RotationChanged(RotationChangedEventArgs evtArgs)
        {
            Console.WriteLine("Rotation Changed event captured");
        }

        void diagram1_MouseClick(object sender, MouseEventArgs e)
        {
            Node node = (Node)this.diagram1.Controller.GetNodeUnderMouse(e.Location);
            if (node != null)
            {
                if (e.Button == MouseButtons.Left)
                {
                    Console.WriteLine("Node Left Click event captured");
                }
                if (e.Button == MouseButtons.Right)
                {
                    Console.WriteLine("Node Right Click event captured");
                }
            }
        }

        void EventSink_SizeChanged(SizeChangedEventArgs evtArgs)
        {
            Console.WriteLine("Node resize event captured");
        }

        void EventSink_PinPointChanging(PinPointChangingEventArgs evtArgs)
        {
            Console.WriteLine("Node Move event captured");
        }

        void EventSink_NodeDoubleClick(NodeMouseEventArgs evtArgs)
        {
            Console.WriteLine("Node Double Click event captured");
        }

        void EventSink_NodeClick(NodeMouseEventArgs evtArgs)
        {
            Console.WriteLine("Node Click event captured");
        }

        void diagram1_DragDrop(object sender, DragEventArgs e)
        {
            Console.WriteLine("Node Drag drop event captured");
        }
    }
}